<?php
/*
Plugin Name: WooShare
Plugin URI: http://wordpress.org/extend/plugins/wooshare/
Description: WooShare is a plugin that lets you add share links to the bottom of each of your posts. You can customize every link and add custom links easily!
Version: 1.0.0.2
Author: Hen Asraf
Author URI: http://webasraf.wosaic.net

	Copyright 2009  Hen Asraf  (email : henasraf@wosaic.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
add_action('admin_menu', 'wooshare_settings_page');
add_action('wp_head', 'wooshare_stylesheet');
add_action('the_ID', 'wooshare_get_title');
add_filter('the_content', 'show_wooshare_links');
register_activation_hook(__FILE__, 'wooshare_install');

$wooshare_post_info = Array();

function wooshare_install()
{
	global $wpdb;
	$table_name = $wpdb->prefix . 'wooshare_links';
	if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) // if table doesn't exits
	{
		$sql = "CREATE TABLE " . $table_name . " (
					id int(11) NOT NULL AUTO_INCREMENT,
					name tinytext NOT NULL,
					text tinytext,
					image tinytext,
					title tinytext,
					url tinytext NOT NULL,
					PRIMARY KEY id (id)
				);";
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
		
		$twitter =     "'twitter',
						'Tweet This Post',
						'http://twitter.com/favicon.ico',
						'Click here to share this post on Twitter',
						'http://twitter.com/?status=Reading: \\\"%title%\\\" - %url'";
		
		$facebook =    "'facebook',
						'Share on Facebook',
						'http://www.facebook.com/favicon.ico',
						'Click here to share this post on Facebook',
						'http://www.facebook.com/sharer.php?u=%url%'";
					
		$delicious =   "'delicious',
						'Share on Delicious',
						'http://www.delicious.com/favicon.ico',
						'Click here to share this post on Delicious',
						'http://www.delicious.com/post?url=%url%'";
						
		$digg =        "'digg',
						'Digg This Post',
						'http://www.digg.com/favicon.ico',
						'Click here to share this post on Digg',
						'http://www.digg.com/submit?url=%url%'";
		
		$insert = "INSERT INTO `$table_name` (`name`, `text`, `image`, `title`, `url`)
								VALUES ($twitter),($facebook),($delicious),($digg);";
		
		$result = $wpdb->query($insert);
	}
}


function show_wooshare_links($content)
{
	global $wpdb, $wooshare_post_info;
	$table_name = $wpdb->prefix . 'wooshare_links';
	$query = "SELECT `name`,`url`,`image`,`text`,`title` FROM `$table_name`";
	$buttons = $wpdb->get_results($query, OBJECT);
	$insert = '';
	foreach ($buttons as $button)
		$insert .= get_wooshare_link($GLOBALS['wooshare_id'], $button);
	return $content . '<div class="wooshare_links">'.$insert.'</div>';
}
function get_wooshare_link($post_id=null, $button)
{
		if ($post_id !== null)
			$post = get_post($post_id,OBJECT);
		$post->guid = get_permalink($post->ID);
		$find = Array(
			"\\",
			'%25title%25',
			'%25url%25',
			'%25date%25'
		);
		$replace = Array(
			"",
			$post->post_title,
			$post->guid,
			$post->post_date
		);
		if ($post_id === null)
		{
			$find = "\\"; $replace = "";
		}
		$url = explode('?',$button->url);
		$url[1] = urlencode($url[1]);
		$button->url = implode('?',$url);
		$button->url = str_replace($find, $replace, $button->url);
		$text = '<a href="' . $button->url . '" class="wooshare_link wooshare_' . $button->name . '" title="' . $button->title . '" target="_blank"><img src="' . $button->image . '" alt="" class="wooshare_icon wooshare_' . $button->name . '_icon" /> ' . $button->text . '</a>';
		return $text;
}
function wooshare_settings_page()
{
	add_submenu_page('plugins.php', 'WooShare Settings', 'WooShare Settings', 'administrator', 'wooshare/options.php');
}
function wooshare_options()
{
	include('options.php');
}
function wooshare_stylesheet()
{
	echo '
<link rel="stylesheet" href="'.get_option('home').'/wp-content/plugins/wooshare/wooshare.css" type="text/css" />
	';
}
function wooshare_get_title($id)
{
	global $wpdb;
	$GLOBALS['wooshare_id'] = $id;
}
?>